;;; " "   "DimDen" 
;;; .. 18.09.04
;;;      fd-@mail.ru
;;;     "Tols.lsp" Peter Best  March 1999f
;;;   :   ^C^C(load "DimDen") DimDen
;;;
;;;  .   . . 
;;;  ..  ( ) . 


(defun C:DimDen (/ obj data)
  (setvar "CMDECHO" 0)
  (setvar "blipmode" 0)
  (setq style_old (getvar "dimstyle")
        appname	   "DimDen.lsp"
	spr      "0"
	diam     "0"
	simm     "0"
	A1       "1"
	A2       "0"
	A3       "0"
	A4       "0"
	A5       "0"
	polka    "0"
	ramka    "0"
	sh1      "0"
	shaft1	 "7"
	shaft2	 "13"
	hole	 "8"
	ra       ""
	toler1   ""
	toler2   ""
	edit1    ""
	edit2    ""
	edit3    ""
	edit4    ""
	flsize   ""
	str1      0
	n_skb     0
	step      2
  )

(if (not (and (setq ss (ssget "_i"))
              (= (sslength ss) 1)
              (setq obj (ssname ss 0))))
(progn (sssetfirst)
(setq obj  (car (entsel "\n   :" )))))
 
(setq data (entget obj))

(if 
(eq (cdr (assoc 0 data)) "DIMENSION")
    (progn
      (setq text_obj (assoc 1 data)
	    text     (cdr text_obj))
      
(command "_-dimstyle" "_r" (cdr (assoc 3 data)))

(setq elst (entget obj '("ACAD")))

(setq dim_typ (cdr (assoc 70 data)))
(if (> dim_typ 127) (setq dim_typ (- dim_typ 128)))
(if (> dim_typ 31) (setq dim_typ (- dim_typ 32)))
      
(setq elst1 (cadr(assoc -3 elst))
      dgap_lst (member (cons 1070 '147)  elst1))
(if (null dgap_lst)
(setq dgap (getvar "DIMGAP"))
(setq dgap (cdr (cadr dgap_lst))))
            
(if (< dgap 0) (setq ramka "1"))
(setq ramka1 ramka)

(if (wcmatch text "*\\S^*")(progn  
(setq dgap (abs (getvar "DIMGAP")))
(if (= ramka "1") (setq dgap (- dgap)))))
 
(setq dTM_lst (member (cons 1070 '279)  elst1))
(if (null dTM_lst)
(setq dTM (getvar "DIMTMOVE"))
(setq dTM (cdr (cadr dTM_lst))))

(setq dtoh_lst (member (cons 1070 '74)  elst1))
(if (null dtoh_lst)
(setq dtoh (getvar "DIMTOH"))
(setq dtoh (cdr (cadr dtoh_lst))))

(if (and (= dTM 1)(= dtoh 1))(setq polka "1"))
(setq polka1 polka)

(setq dSD (cdr (cadr (member (cons 1070 '281)  elst1))))
(setq dSE (cdr (cadr (member (cons 1070 '75)  elst1))))

(if (and (= dSD 1)(= dSE 1))(setq str1 2)(progn
(setq dSD (cdr (cadr (member (cons 1070 '282)  elst1))))
(setq dSE (cdr (cadr (member (cons 1070 '76)  elst1))))
(if (and (= dSD 1)(= dSE 1))(setq str1 2))
))

(setq dfac_lst (member (cons 1070 '144)  elst1))
(if (null dfac_lst)
(setq dfac (getvar "DIMLFAC"))
(setq dfac (cdr (cadr dfac_lst))))
(setq dfac_lst dfac)

(setq loc (VL-POSITION dfac '(0   10.0   5.0   4.0   2.5
              2.0   1.0   0.5   0.4   0.25   0.2   0.1)))

(if (null loc)(setq loc "0")
(setq loc (rtos loc)))

(if (<  dfac 1)
(setq dfac (strcat " " (vl-string-subst "" ".0" (rtos (/ 1 dfac) 2 2)) ":1"))
(setq dfac (strcat " 1:" (vl-string-subst "" ".0" (rtos dfac 2 2)))))
      
(setq ddec (member (cons 1070 '271)  elst1))
(if (null ddec)
(setq ddec (getvar "dimdec"))
(setq ddec (cdr (cadr ddec))))  

(setq dim_txt2  (cdr (assoc 42 data))
      dim_txt (rtos dim_txt2 2 ddec))
      
(if (= dim_typ 3)(setq dim_txt (strcat "" dim_txt))
(if (= dim_typ 4)(setq dim_txt (strcat "R" dim_txt))))

(if (or (= dim_typ 5) (= dim_typ 2)) (progn
(setq dim_typ "ANGL"
      dadec (member (cons 1070 '179)  elst1))
(if (null dadec)
(setq dadec (getvar "dimadec"))
(setq dadec (cdr (cadr dadec))))
(setq dim_txt (strcat (angtos dim_txt2 0 dadec) ""))))
      
      
(setq dim_txt (strcat "<" dim_txt ">")
      dim_txt1 dim_txt)

(setq skb (list "" "(" "[" "<")
      skb1 (list "" ")" "]" ">"))

(if (= (strlen  text) 0)(setq dim_txt dim_txt1)(progn

(while (/= (vl-string-search "%%D" (strcase text)) nil)
(setq text (VL-STRING-SUBST "" "%%d" text)
  text (VL-STRING-SUBST "" "%%D" text)))

(if (= "\\A1;" (substr text 1 4))
(setq text (substr text 5)))

(setq KOL_niz (vl-string-search "\\X" text))
(if (/= KOL_niz nil)
(setq edit4 (substr text (+ KOL_niz 3))
      text (substr text 1 KOL_niz)))

(if (> (strlen text) 5)
(if (= "\\S*^;" (substr text (- (strlen text) 4)))
(setq text (substr text 1 (- (strlen text) 5))
      spr "1")))

(if (> (strlen text) 6)
(if (= "\\S**^;" (substr text (- (strlen text) 5)))
(setq text (substr text 1 (- (strlen text) 6))
      spr "2")))

(if (> (strlen text) 7)
(if (= "\\S***^;" (substr text (- (strlen text) 6)))
(setq text (substr text 1 (- (strlen text) 7))
      spr "3")))

(if (wcmatch text "<*?>")
(setq n_skb 3)
(if (wcmatch text "`[*`]")
(setq n_skb 2)
(if (wcmatch text "(*)")
(setq n_skb 1))))

(if (/= n_skb 0)(setq text (substr text 2 (- (strlen text) 2))))

(setq kol_tol (vl-string-search "\\" text)) 
(if (/= kol_tol nil)
(setq s (substr text (+ 2 kol_tol))
      kol_s (vl-string-search "S" s)
      s (substr s (+ 2 kol_s))
      kol_ss (vl-string-search "^" s)
      toler1 (substr s 1 kol_ss)
      kol_s (vl-string-search "\\" s)
      toler2 (substr s (+ 2 kol_ss)(- kol_s (+ 2 kol_ss)))
      s (substr s (+ 2 kol_s))
      kol_ss (vl-string-search ";" s)
      edit3 (substr s (+ 2 kol_ss))
      text (substr text 1 kol_tol)))

(if (= edit3 "")
(setq edit3 (VL-STRING-RIGHT-TRIM "*)" text)
      edit3 (substr text (+ 1 (strlen edit3)))
      text (VL-STRING-RIGHT-TRIM "*)" text)))

(setq KOL_p (vl-string-search "%%P" (strcase text)))

(if (/= KOL_p nil)
(setq simm "1"
      toler1 (substr text (+ KOL_p 4))
      toler2 (strcat "-" toler1)
      toler1 (strcat "+" toler1)
      text (substr text 1 KOL_p)))

(setq KOL_TXT (vl-string-search "<>" text))
      
(setq KOL_c (vl-string-search "%%C" (strcase text))) 
    
(if (>= KOL_TXT 1) (progn		     
(if (and (/= KOL_c nil)(= 3 (- KOL_TXT KOL_c)))(setq diam "1"))
(if (= (substr text KOL_TXT 1) "R")(setq diam "2"))
(if (= (substr text KOL_TXT 1) "M")(setq diam "3"))  ;.M
(if (= (substr text KOL_TXT 1) "")(setq diam "3"))  ;.
(if (/= KOL_TXT nil)(setq edit1 (substr text 1 KOL_TXT)))
(if (= diam "1")(setq edit1 (substr text 1 (- KOL_TXT 3))))
(if (or (= diam "2")(= diam "3"))
(setq edit1 (substr text 1 (- KOL_TXT 1))))
))

(if (>= KOL_TXT 0)
(setq edit2 (substr text (+ 3 KOL_TXT))))

(if (null KOL_TXT)(progn
(setq dim_txt text)   
(if (/= (strlen  dim_txt)
(strlen  (rtos (atof (VL-STRING-TRANSLATE ",'0" ".234" dim_txt)))))
(setq edit2 dim_txt
      dim_txt ""))

(if (/= KOL_c nil)(progn
(setq diam "1"
      edit1 (substr text 1 KOL_c)
      dim_txt (substr text (+ KOL_c 4))
      dim_txt (rtos (atof (VL-STRING-TRANSLATE ",0" ".1" dim_txt))))
(if (= dim_txt "0")(setq dim_txt ""))
(setq edit2 (substr text (+ 4 KOL_c (strlen  dim_txt)))
      dim_txt (substr text (+ KOL_c 4)(strlen  dim_txt)))
)
(progn
(setq KOL_c (vl-string-search "R" text))
(if (/= KOL_c nil)(setq diam "2")
(progn
(setq KOL_c (vl-string-search "M" text))
(if (/= KOL_c nil)(setq diam "3")
)))
(if (/= KOL_c nil)(progn
(setq edit1 (substr text 1 KOL_c)
      dim_txt (substr text (+ KOL_c 2)))
(if (= diam "3")(setq dim_txt (VL-STRING-TRANSLATE ",.x" "11.." dim_txt)))
(setq dim_txt (rtos (atof (VL-STRING-TRANSLATE ",0" ".1" dim_txt))))
(if (= dim_txt "0")(setq dim_txt ""))
(setq edit2 (substr text (+ 2 KOL_c (strlen  dim_txt)))
      dim_txt (substr text (+ KOL_c 2)(strlen  dim_txt)))
))
))
))
))
)
(progn (sssetfirst)
(princ "\n  ")
(exit))
)


(if (findfile "DimDen.dcl")
    (progn
      (setq DCL_ID (load_dialog "DimDen"))
      
      (WHILE (>= step 2)
      
      (if (not (new_dialog "DimDen" DCL_ID))
	(exit)
      )

      (update)
	(sh)
	
      (action_tile "shaft1" "(setq shaft1 $value)(update)")
      (action_tile "shaft2" "(setq shaft2 $value)(update)")
      (action_tile "hole" "(setq hole $value)(update)")
      (action_tile "accept" "(done_dialog 1) (setq ok_button T)")
      (action_tile "cancel" "(done_dialog 0) (setq ok_button nil)")
      (action_tile "loc" "(setq loc $value)(update)")
      (action_tile "edit1" "(setq edit1 $value)")
      (action_tile "edit2" "(setq edit2 $value)")
      (action_tile "edit3" "(setq edit3 $value)")
      (action_tile "edit4" "(setq edit4 $value)")
      (action_tile "toler1" "(setq toler1 $value)(update)")
      (action_tile "toler2" "(setq toler2 $value)(update)")
      (action_tile "nomin" "(setq dim_txt \"<>\")(update)")
      (action_tile "spr" "(setq spr $value)")
      (action_tile "diam" "(setq diam $value)(update)")
      (action_tile "ramka" "(setq ramka $value)")
      (action_tile "polka" "(setq polka $value)")
	
(action_tile "simm" "(setq simm $value A1 \"0\" A2 \"0\" A3 \"0\" A4 \"0\" A5 \"0\")(update)")
(action_tile "A1" "(setq A1 $value simm \"0\" A2 \"0\" A3 \"0\" A4 \"0\" A5 \"0\")(update)")
(action_tile "A2" "(setq A2 $value simm \"0\" A1 \"0\" A3 \"0\" A4 \"0\" A5 \"0\")(update)")
(action_tile "A3" "(setq A3 $value simm \"0\" A1 \"0\" A2 \"0\" A4 \"0\" A5 \"0\")(update)")
(action_tile "A4" "(setq A4 $value simm \"0\" A1 \"0\" A2 \"0\" A3 \"0\" A5 \"0\")(update)")
(action_tile "A5" "(setq A5 $value simm \"0\" A1 \"0\" A2 \"0\" A3 \"0\" A4 \"0\")(update)")

(action_tile "sh1" "(sh)(setq sh1 $value simm \"1\" toler1 (nth (atoi sh1) flsize))(update)")

      (action_tile "otv" "(setq elem1 edit1)(openDimDen3 dcl_id)
      (setq edit1 elem1)(update)")
      
      (action_tile "otv1" "(setq elem1 edit4)(openDimDen3 dcl_id)
      (setq edit4 elem1)(update)")

      (action_tile "fas"  "(openDimDen4 dcl_id)(update)")

      (action_tile "dim_txt" "(setq dim_txt $value)(update)")
      (mode_tile "dim_txt" 2)
      
      (set_tile  "ramka" ramka)
      (set_tile  "polka" polka)
      (set_tile  "diam" diam)
      (set_tile  "spr" spr)
      (set_tile  "qqq" " >>")
      (set_tile  "nomin" " <>")
      (action_tile "skb"  "(skb_lst)(update)")
      (action_tile "skb1"  "(skb_lst)(update)")
      (action_tile "info"  "(openinfo dcl_id)")
      (if ( = dim_typ "ANGL")
      (action_tile "qqq"  "(openDimDen2 dcl_id)(update)")
      (action_tile "qqq"  "(if ( = diam \"3\")
      (openDimDen5 dcl_id)(openDimDen1 dcl_id))(update)"))

(ACTION_TILE "str" "(if (>= str1 2)(setq str1 1)(DONE_DIALOG 3))(update)")

(SETQ step (START_DIALOG))

(if (= step 3)(PROGN
(command "_DIMOVERRIDE" "DIMSD1" 1 "DIMSE1" 1 "DIMSD2" 0 "DIMSE2" 0 "" obj "")
(initget 128)
(IF (/= NIL (GETKWORD "\n  
	      \n :[Enter]/ :[ ][Enter]"))
(setq str1 3)(setq str1 4))
(command "_DIMOVERRIDE" "DIMSD1" 0 "DIMSE1" 0 "" obj "")
  ))	
      )
    )  
    (alert "Unable to find DimDen.dcl")
  )

(if (= diam "1")(setq text (strcat "%%c" text))
(if (= diam "2")(setq text (strcat "R" text))
(if (= diam "3")(setq text (strcat "M" text)))))

(setq text (vl-string-subst "," "." text)
      text (strcat text edit2))

(if (= simm "1")
(if (/= toler1 "")(setq text (strcat text "%%p" (vl-string-subst "" "+" toler1))))
(if (/= toler1 toler2) (setq text (strcat text
             "\\H.7x;\\S" toler1 "^" toler2 ";\\H1.428x;"))))
  
(setq edit3 (strcat edit3  (nth n_skb skb1)))

(if (= spr "1")
(setq edit3 (strcat edit3 "\\S*^;"))
(if (= spr "2")
(setq edit3 (strcat edit3 "\\S**^;"))
(if (= spr "3")
(setq edit3 (strcat edit3 "\\S***^;")))))

(if (/= edit4 "")(setq edit4 (strcat "\\X" edit4)))

(setq text
(strcat (nth n_skb skb) edit1 text edit3 edit4))

(while (/= (vl-string-search "" text) nil)
(setq text (VL-STRING-SUBST "%%d" "" text)))

(if (= text "<>")(setq text ""))
  
(setq data (subst (cons '1 text) text_obj data))

      (if (= ok_button T)
	  (progn
      (entmod data)
      (entupd (cdar data))
      (entupd obj)
      (redraw)

(if (and (/= loc1 0) (/= loc1 dfac_lst))
;(progn (command "_.change" obj "" "_p" "_c" 6 "") ; .  ..
(command "_DIMOVERRIDE" "dimlfac" loc1 "" obj ""))
;)              ;  ";"   2-   .  ..

(if (wcmatch text "*\\S^*")
(setq dgap (* dgap 3)))     

(if (wcmatch text "*\X*")
(command "_dimedit" "_h" "_p" ""))
      
(if (/= ramka ramka1)
(setq dgap (- dgap)))  
  
(command "_DIMOVERRIDE" "DIMGAP" dgap "" obj "")

(if (/= polka polka1)
(command "_DIMOVERRIDE" "DIMTOH" (atoi polka) "DIMTMOVE" (atoi polka) "" obj ""))


(if (= str1 4)
(command "_DIMOVERRIDE" "DIMSD1" 1 "DIMSE1" 1 "" obj "")
(if (= str1 3)
(command "_DIMOVERRIDE" "DIMSD2" 1 "DIMSE2" 1 "" obj "")
(if (= str1 1)
(command "_DIMOVERRIDE" "DIMSD1" 0 "DIMSE1" 0 "DIMSD2" 0 "DIMSE2" 0 "" obj ""))))

))

(command "_-dimstyle" "_r" style_old)
(setvar "CMDECHO" 1))


(defun openinfo (dc /) 
(if (not (new_dialog "info" dc))(exit))
(start_dialog))


(defun openDimDen5 (dc /) 
(if (not (new_dialog "DimDen5" dc))(exit))

(setq file  (findfile "DimDen8724.lst")
      fp    (open file "r")
      item  (read-line fp)
      REZB_P (vl-string-subst "." "," dim_txt)
      REZB_P (atof (vl-string-left-trim "<R" REZB_P))
      norm1 -1
      REZB_Q 0
      REZB ""
      norm '())

  
(while item  
(setq WWW (READ item)
      WWW (VL-STRING-TRANSLATE "{}" "()" WWW)
      WWW (vl-string-subst "                " "@" WWW)
      WWW (vl-string-subst "                " "@" WWW)
      WWW (vl-string-subst "(" " (" WWW)
      norm (APPEND norm (LIST WWW))
      WWW (vl-string-trim " (M)" WWW)
      norm1 (1+ norm1)
      item (read-line fp))

(if (>= REZB_P (atof (vl-string-subst "." "," WWW)))
(setq REZB_Q norm1))
  
)
  
  
(close fp)

(REZB_P_list)

(start_list "REZB_M")
(MAPCAR 'ADD_LIST norm)
(end_list)
(set_tile  "REZB_M" (rtos (+ 2 REZB_Q)))
(set_tile  "REZB_M" (rtos REZB_Q))

(action_tile "REZB_M" "(SETQ REZB_Q (atoi $value))(REZB_P_list)")

(start_dialog))


(defun REZB_P_list ()
  
(setq fp (open file "r")
      item (read-line fp)
      norm1 '())

(REPEAT REZB_Q
(setq item (read-line fp)))

(close fp)  

(while (> (STRLEN item) 0)
(setq WWW (VL-PRINC-TO-STRING (READ item))
      item (substr item (+ 2 (STRLEN WWW)))
      WWW (vl-string-subst " " "*" WWW)
      WWW (VL-STRING-TRANSLATE "{}" "()" WWW)
      norm1 (APPEND norm1 (LIST WWW)))
  )

(setq REZB (car norm1)
      REZB (vl-string-trim "@()" REZB)
      norm1 (cdr norm1)
      WWW REZB
      REZB_P (car norm1))

(start_list "REZB_P")
(MAPCAR 'ADD_LIST norm1)
(end_list)
(mode_tile "REZB_P" 2)
  
(REZB_W)

(action_tile "REZB_P" "(setq REZB_P (nth (atoi $value) norm1))(REZB_W)")
(action_tile "accept" "(setq dim_txt (vl-string-left-trim \"M\" REZB)) 
(done_dialog)")
(action_tile "cancel" "(done_dialog)")
  
)


(defun REZB_W ()
(setq REZB_P (vl-string-trim "()" REZB_P))
(if (wcmatch REZB_P "* ")
(setq REZB_P "")(setq REZB_P (strcat "x" REZB_P)))
(setq REZB (strcat WWW REZB_P))
(set_tile  "REZB" REZB)
)


(defun openDimDen4 (dc /) 
(if (not (new_dialog "DimDen4" dc))(exit))

(setq flsize ' ("x45" "max" "min" "" "max" "min" "-6H" "-6g" " LH" ""))
  
(start_list "otv11")
(MAPCAR 'ADD_LIST flsize)
(end_list)

(action_tile "otv11" "(SETQ edit2 (nth (atoi $value) flsize))
(if (/= simm \"1\")(SETQ A1 \"1\" A2 \"0\" A3 \"0\" A4 \"0\" A5 \"0\"))
(done_dialog)")
  
(start_dialog))


(defun openDimDen3 (dc /) 
(if (not (new_dialog "DimDen3" dc))(exit))

(setq flsize ' ("." "" "" "" "" "." "" ""))

(start_list "otv11")
(MAPCAR 'ADD_LIST flsize)
(end_list)  

(action_tile "otv11" "(SETQ otv $value)(otv_fun)(done_dialog)")
  
(start_dialog))


(defun otv_fun ()

(setq elem1 (atoi elem1))
  
(if (or (< elem1 2)(= otv "6")(= otv "7"))
(setq elem1 (nth (atoi otv) flsize))(PROGN  

(if (= otv "0")
(setq elem "."))

(if (= otv "1")
(if (< elem1 5)(setq elem "")(setq elem "")))

(if (= otv "2")
(if (< elem1 5)(setq elem "")(setq elem "")))

(if (= otv "3")
(if (< elem1 5)(setq elem "")(setq elem "")))

(if (= otv "4")
(if (< elem1 5)(setq elem "")(setq elem "")))

(if (= otv "5")
(setq elem "."))

(setq elem1 (STRCAT (rtos elem1) elem))

)))


(defun openDimDen2 (dc /) 
(if (not (new_dialog "DimDen2" dc))(exit))

(setq flsize2 ' ("0" "@@015'" "@030'" "@@045'" "@1" "@@130'" "@2"
		 "@@230'" "@3" "@4" "5" "@6" "@7" "@8" "@@9"
		 "@10" "@@12" "15" "@@18" "20" "@@22" "@@25" "30"
		 "@@35" "@40" "45" "@@50" "@@55" "60" "@@65" "@@70"
		 "@75" "@@80" "@@85" "90" "@@100" "@@110" "120"
		 "@@135" "@@150" "@@165" "@@180" "@@270" "@@360")
      flsize ' ()
      nnn 0) 

(REPEAT 44
(setq flsize3 (nth nnn flsize2)
      flsize3 (vl-string-subst "                 " "@" flsize3)
      flsize3 (vl-string-subst "                 " "@" flsize3)
      flsize (APPEND flsize (LIST flsize3))
      nnn (1+ nnn)
	))
  
(start_list "skb11")
(MAPCAR 'ADD_LIST flsize)
(end_list)  

(action_tile "skb11" "(SETQ dim_txt (nth (atoi $value) flsize))(done_dialog)")
  
(start_dialog))

(defun openDimDen1 (dc /) 
(if (not (new_dialog "DimDen1" dc))(exit))

(setq bbb 8)
(set_tile  "ra40" "1")
(norm_lst1)
(action_tile "ra5" "(setq bbb 1)(norm_lst1)")
(action_tile "ra10" "(setq bbb 2)(norm_lst1)")
(action_tile "ra20" "(setq bbb 4)(norm_lst1)")
(action_tile "ra40" "(setq bbb 8)(norm_lst1)")

(action_tile "skb11" "(setq aa 1)(norm_lst)
(SETQ dim_txt (nth (atoi $value) norm2))(done_dialog)")

(action_tile "skb22" "(setq aa 10)(norm_lst)
(SETQ dim_txt (nth (atoi $value) norm2))(done_dialog)")

(action_tile "skb33" "(setq aa 100)(norm_lst)
(SETQ dim_txt (nth (atoi $value) norm2))(done_dialog)")

(action_tile "skb44" "(setq aa 1000)(norm_lst)
(SETQ dim_txt (nth (atoi $value) norm2))(done_dialog)")

(start_dialog))


(defun norm_lst1 ()

(setq aa 1)
(norm_lst)      
(start_list "skb11")
(MAPCAR 'ADD_LIST norm2)
(end_list)

(setq aa 10)     
(norm_lst)
(start_list "skb22")
(MAPCAR 'ADD_LIST norm2)
(end_list)

(setq aa 100)     
(norm_lst)
(start_list "skb33")
(MAPCAR 'ADD_LIST norm2)
(end_list)

(setq aa 1000)     
(norm_lst)
(start_list "skb44")
(MAPCAR 'ADD_LIST norm2)
(end_list)

)


(defun norm_lst ()

(setq nnn 0
      norm2 ' ()
      flsize ' ( 0.1 0.105 0.11 0.115 0.12 0.13 0.14 0.15 0.16 0.17 0.18 0.19 0.2
	       0.21 0.22 0.24 0.25 0.26 0.28 0.3 0.32 0.34 0.36 0.38 0.4 0.42
	       0.45 0.48 0.5 0.53 0.56 0.6 0.63 0.67 0.71 0.75 0.8 0.85 0.9 0.95 ))

(while (< nnn 40)
(setq	norm1 (nth nnn flsize)
	norm1 (RTOS (* norm1 aa))
	norm1 (vl-string-subst "," "." norm1)
	norm2 (APPEND norm2 (LIST norm1))
	nnn (+ nnn bbb))
)
)

(defun skb_lst ()  
(setq n_skb (1+ n_skb))
(if (= n_skb 4)(setq n_skb 0))
)


(defun sh ()
(if ( = dim_typ "ANGL") 
(setq flsize '("" "10'" "15'" "30'" "1" "130'" "2" "5"))
(setq flsize '("" "0,1" "0,15" "0,2" "0,4" "0,5" "0,6" "0,8" "1,0" "1,2" "1,5" "2,0")))
(start_list "sh1")
(MAPCAR 'ADD_LIST flsize)
(end_list)
)

(defun update ()

(if (<= str1 1)(setq str " I<-->I")(setq str " I<-"))
  
(set_tile  "sh1" sh1)
(set_tile  "str" str)
(set_tile  "A1" A1)
(set_tile  "simm" simm)

(start_list "skb")
(add_list (nth n_skb skb))
(end_list)
(start_list "skb1")
(add_list (nth n_skb skb1))
(end_list)
  
(setq	flsize '(0 10 5 4 2.5 2 1 0.5 0.4 0.25 0.2 0.1))

(setq loc1 (nth (atoi loc) flsize))

(if (wcmatch dim_txt "<*>")(progn
(MODE_TILE "loc" 0)
(setq dim_txt (vl-string-subst
		       (rtos (* loc1 (/ dim_txt2 dfac_lst)) 2 ddec)
		       (rtos dim_txt2 2 ddec) dim_txt1))
(if (= loc1 0)(progn (setq dim_txt dim_txt1)
(set_tile "dfac" dfac))(set_tile "dfac" "")))
(progn (set_tile "dfac" "")
(MODE_TILE "loc" 1)))

(if (/= dim_txt " ")(setq dim_txt (vl-string-trim " " dim_txt)))  
  
(setq DIA (vl-string-subst "." "," dim_txt)) 

(if (wcmatch DIA "<*>")(setq text "<>")(setq text DIA))

(setq DIA (atof (vl-string-left-trim "<R" DIA)))

(if (= diam "3")(progn (MODE_TILE "shaft1" 1)
		  (MODE_TILE "shaft2" 1)
		  (MODE_TILE "hole" 1)
		  (MODE_TILE "A2" 1)
		  (MODE_TILE "A3" 1)
		  (MODE_TILE "A4" 1)
		  (MODE_TILE "A5" 1)
		  (MODE_TILE "info" 1)
		  (setq uht ""
			lht ""
			ust ""
			lst ""
			cmax "    "
			cmin ""))
  
(if (or (eq DIA 0)( < 3150 DIA))(progn
			 (MODE_TILE "A2" 1)
			 (MODE_TILE "A3" 1)
			 (setq uht ""
			       lht ""
			       ust ""
			       lst ""
			       cmax " "
			       cmin "0...3150 "))
(PROGN (MODE_TILE "shaft1" 0)
  (MODE_TILE "shaft2" 0)
  (MODE_TILE "hole" 0)
  (MODE_TILE "A2" 0)
  (MODE_TILE "A3" 0)
  (MODE_TILE "A4" 0)
  (MODE_TILE "A5" 0)
  (MODE_TILE "info" 0)

(setq DIA (cond
((<= DIA 3) 0)
((<= DIA 6) 1)
((<= DIA 10) 2)
((<= DIA 14) 3)
((<= DIA 18) 4)
((<= DIA 24) 5)
((<= DIA 30) 6)
((<= DIA 40) 7)
((<= DIA 50) 8)
((<= DIA 65) 9)
((<= DIA 80) 10)
((<= DIA 100) 11)
((<= DIA 120) 12)
((<= DIA 140) 13)
((<= DIA 160) 14)
((<= DIA 180) 15)
((<= DIA 200) 16)
((<= DIA 225) 17)
((<= DIA 250) 18)
((<= DIA 280) 19)
((<= DIA 315) 20)
((<= DIA 355) 21)
((<= DIA 400) 22)
((<= DIA 450) 23)
((<= DIA 500) 24)
((<= DIA 560) 25)
((<= DIA 630) 26)
((<= DIA 710) 27)
((<= DIA 800) 28)
((<= DIA 900) 29)
((<= DIA 1000) 30)
((<= DIA 1120) 31)
((<= DIA 1250) 32)
((<= DIA 1400) 33)
((<= DIA 1600) 34)
((<= DIA 1800) 35)
((<= DIA 2000) 36)
((<= DIA 2240) 37)
((<= DIA 2500) 38)
((<= DIA 2800) 39)
( T 40)))

  (setq	flsize '("0to3"		     "over3to6"
		 "over6to10"	     "over10to14"
		 "over14to18"	     "over18to24"
		 "over24to30"	     "over30to40"
		 "over40to50"	     "over50to65"
		 "over65to80"	     "over80to100"
		 "over100to120"	     "over120to140"
		 "over140to160"	     "over160to180"
		 "over180to200"	     "over200to225"
		 "over225to250"	     "over250to280"
		 "over280to315"	     "over315to355"
		 "over355to400"	     "over400to450"
		 "over450to500"	     "over500to560"
		 "over560to630"	     "over630to710"
		 "over710to800"	     "over800to900"
		 "over900to1000"	     "over1000to1120"
		 "over1120to1250"	     "over1250to1400"
		 "over1400to1600"	     "over1600to1800"
		 "over1800to2000"	     "over2000to2240"
		 "over2240to2500"	     "over2500to2800"
		 "over2800to3150"
		)
  )


  (setq diax (nth dia flsize))
  (grab)
  (setq	stddev	(/ (nth (atoi shaft1) dlist) 1000)
	stddev1	stddev
  )
  (if (and (= shaft1 "9") (> shaft2 "3") (< shaft2 "6"))
					; j5 & j6 std dev. for shaft
    (setq stdj56 (/ (nth 22 dlist) 1000))
  )
  (if (and (= shaft1 "9") (= shaft2 "6")) ; j7 std dev. for shaft
    (setq stdj7 (/ (nth 23 dlist) 1000))
  )
  (if (and (= shaft1 "10") (> shaft2 "2") (< shaft2 "7"))
					; k4-7 std dev. for shaft
    (setq stdk4_7 (/ (nth 24 dlist) 1000))
  )

  (if (> stddev 0)
    (setq flag 3)
    (setq flag 2)
  )
  
  (setq stddev (VL-PRINC-TO-STRING stddev))
  
  (if (= flag 3)
    (setq stddev (strcat "+" stddev))
  )
  
  (setq diax (STRCAT "*" (nth dia flsize)))
  (grab)
  (setq grade (/ (nth (atoi shaft2) dlist) 1000))
  (if (= shaft1 "8")			; js shaft grade
    (setq gradejs (/ grade 2))
  )
  (if (<= (atoi shaft1) 7)
    (setq lst (- stddev1 grade))
    (setq lst (+ stddev1 grade))
  )
  
  (if (> lst 0)
    (setq flag 3)
    (setq flag 2)
  )

(setq lst (VL-PRINC-TO-STRING lst))

  (if (= flag 3)
    (setq lst (strcat "+" lst))
  )

  (setq	uht (/ (nth (+ (atoi hole) 5) dlist) 1000)
        uht (VL-PRINC-TO-STRING uht)
	uht (strcat "+" uht)
  )

  (setq ust stddev)

  (if (> (atof lst) 0)
      (setq temp1 lst
	    lst	ust
	    ust	temp1
      )
  )
  (if (= shaft1 "8")			; js
      (setq ust (strcat "+" (VL-PRINC-TO-STRING gradejs))
            lst (strcat "-" (VL-PRINC-TO-STRING gradejs)))
  )
    
  (if (and (= shaft1 "9") (> shaft2 "3") (< shaft2 "6"))
                                ; j5 & j6 shaft tols    
      (setq ust	(strcat "+" (VL-PRINC-TO-STRING (+ stdj56 grade)))
	    lst	(VL-PRINC-TO-STRING stdj56)
      )
  )
  
  (if (and (= shaft1 "9") (= shaft2 "6")) ; j7 shaft tols
      (setq ust	(strcat "+" (VL-PRINC-TO-STRING (+ stdj7 grade)))
	    lst	(VL-PRINC-TO-STRING stdj7)
      )
  )
  (if (and (= shaft1 "10") (<= shaft2 "2") (> shaft2 "6"))
				; k1_3 & k8+ std dev. for shaft
    (setq lst "0")
  )
  (if (and (= shaft1 "10") (> shaft2 "2") (< shaft2 "7"))
					; k4-7 std dev. for shaft
    (progn
      (setq ust	(strcat "+" (VL-PRINC-TO-STRING (+ stdk4_7 grade)))
	    lst	(VL-PRINC-TO-STRING stdk4_7)
      )
      (if (/= lst "0.0")
	  (setq lst (strcat "+" lst))
      )
    )
  )



  (if (and (= shaft1 "16") (<= dia 5)) ; t
      (setq ust	"Use \"u\""
	    lst	"Use \"u\""
      )
  )
  (if (and (= shaft1 "18") (<= dia 3)) ; v
      (setq ust	"Use \"x\""
	    lst	"Use \"x\""
      )
  )
  (if (and (= shaft1 "20") (<= dia 4)) ; y
      (setq ust	"Use \"z\""
	    lst	"Use \"z\""
      )
  )

;;;Works out maximum condition
;;;Largest hole/smallest shaft
  (setq	flagmax	0
	cmax	(VL-PRINC-TO-STRING (- (atof uht) (atof lst)))
  )

  (while (< (strlen cmax) 5)
    (setq cmax (strcat cmax "0"))
  )

  (if (= (atof cmax) 0)
    (setq cmax "")
  )
  (if (> (atof cmax) 0)
      (setq flagmax 1
	    cmax    (strcat cmax " ")
      )
  )

  (if (< (atof cmax) 0)
    (progn
      (setq flagmax 2
	    cmax    (VL-PRINC-TO-STRING (* (atof cmax) -1))
      )

      (WHILE (< (strlen cmax) 5)
	(setq cmax (strcat cmax "0"))
      ) 
      (setq cmax (strcat cmax " "))
    )
  )

;;;Works out minimum condition
;;;Smallest hole (always zero)/largest shaft
  (setq	cmin	(VL-PRINC-TO-STRING (- 0.0 (atof ust)))
	flagmin	0
  )

  (if (= (atof cmin) 0)
    (setq cmin "")
  )
  (if (> (atof cmin) 0)
    (progn
      (setq flagmin 1)

      (while (< (strlen cmin) 5)
	(setq cmin (strcat cmin "0"))
      )
  
      (setq cmin (strcat cmin " "))
    )
  )

  (if (< (atof cmin) 0)
    (progn
      (setq flagmin 2
	    cmin    (VL-PRINC-TO-STRING (* (atof cmin) -1))
      )

      (while (< (strlen cmin) 5)
	(setq cmin (strcat cmin "0"))
      )       
      (setq cmin (strcat cmin " "))
    )
  )

  (if (and (= flagmax flagmin) (< (atof cmax) (atof cmin)))
      (setq temp1 cmax
	    cmax  cmin
	    cmin  temp1
      )
  )
  (if (or
	(and (= shaft1 "16") (<= dia 5))
	(and (= shaft1 "18") (<= dia 3))
	(and (= shaft1 "20") (<= dia 4))
	)
      (setq cmax ""
	    cmin ""
      )
  )


(if (or
(and (= shaft1 "9") (>= shaft2 "0") (< shaft2 "4"))
(and (= shaft1 "9") (>= shaft2 "7")))
  (setq ust	  ""
	lst	  ""
	cmax  ""
	cmin  ""))


(if (> dia 24) (if (or 
(= shaft1 "0") (= shaft1 "1") (= shaft1 "2") (= shaft1 "9")
(= shaft1 "18") (= shaft1 "19") (= shaft1 "20")
(= shaft1 "21") (= shaft1 "22") (= shaft1 "23")) ; a,b,c,j,v,x,y,z
      (setq ust	  ""
	    lst	  ""
	    cmax  ""
	    cmin  ""
      )
  ))


(setq lht "0.0")

;(raf) ; ";"     .. 

)))

(if (= simm "1")(progn
(setq toler1 (vl-string-left-trim "+-" toler1)
      toler2 toler1)
(if (/= toler1 "")
(setq toler2 (strcat "-" toler2)
      toler1 (strcat "+" toler1)))))


(setq	flsize '("a"   "b"   "c"   "d"	 "e"   "f"   "g"   "h"	 "js"
		 "j"   "k"   "m"   "n"	 "p"   "r"   "s"   "t"	 "u"
		 "v"   "x"   "y"   "z"
		))
  
(setq let (nth (atoi shaft1) flsize))

(setq num (rtos (+ 1 (atoi shaft2))))
(setq	flsize '("H6" "H7" "H8" "H9" "H10" "H11" "H12" "H13" "H14" "H15" "H16"))
(setq holesize (nth (atoi hole) flsize))

(if (= A2 "1")
(setq edit2 (strcat  holesize "(")
      edit3 (VL-STRING-LEFT-TRIM ")" edit3)
      edit3 (strcat ")" edit3)
      toler1 uht
      toler2 ""))

(if (= A3 "1")
(setq edit2 (strcat  let num "(")
      edit3 (VL-STRING-LEFT-TRIM ")" edit3)
      edit3 (strcat ")" edit3)
      toler1 ust
      toler2 lst))

(if (= A4 "1")
(setq edit2 holesize
      toler1 ""
      toler2 ""            
      edit3 (VL-STRING-LEFT-TRIM ")" edit3)))

(if (= A5 "1")
(setq edit2 (strcat  let num )
      toler1 ""
      toler2 ""
      edit3 (VL-STRING-LEFT-TRIM ")" edit3)))
      
(if (= toler1 "0.0")(setq toler1 ""))
(if (= toler2 "0.0")(setq toler2 ""))  

(setq toler1 (vl-string-subst "," "." toler1)
      toler2 (vl-string-subst "," "." toler2))

  (set_tile  "edit1" edit1)
  (set_tile  "edit2" edit2)
  (set_tile  "edit3" edit3)
  (set_tile  "edit4" edit4)
  (set_tile  "toler1" toler1)
  (set_tile  "toler2" toler2)
  (set_tile "dim_txt" dim_txt)

(if (/= (rtos (ATOF ust)) "0")
      (while (< (strlen ust) 6)
	(setq ust (strcat ust "0"))
      )
  )

(if (/= (rtos (ATOF lst)) "0")
      (while (< (strlen lst) 6)
	(setq lst (strcat lst "0"))
      )
  )

(if (/= (rtos (ATOF uht)) "0")
      (while (< (strlen uht) 6)
	(setq uht (strcat uht "0"))
      )
  )

(SETQ ust (strcat ust "   " ra))

(if ( = dim_typ "ANGL")(progn
			 (MODE_TILE "loc" 1)
			 (MODE_TILE "shaft1" 1)
			 (MODE_TILE "shaft2" 1)
			 (MODE_TILE "hole" 1)
			 (MODE_TILE "A2" 1)
			 (MODE_TILE "A3" 1)
			 (MODE_TILE "A4" 1)
			 (MODE_TILE "A5" 1)
			 (MODE_TILE "diam" 1)
			 (MODE_TILE "info" 1)
			 (setq uht ""
			       lht ""
			       ust ""
			       lst ""
			       dfac ""
			       loc  "0"
			       cmax "   "
			       cmin "  ")))
  
  (set_tile "loc" loc)
  (set_tile "ust" ust)
  (set_tile "lst" lst)
  (set_tile "uht" uht)
  (set_tile "lht" lht)
  (set_tile "cmax" cmax)
  (set_tile "cmin" cmin)
  
)

;;; This function will read a list
;;; and create the variable "dlist"

(defun grab ()
  (setq	dlist nil
	diax  (strcat "*" diax)
	file  (findfile "DimDen.lst")
	fp    (open file "r")
	item  (read-line fp)
  )
  (while item
    (if	(= item diax)
      (setq data1 (read-line fp)
	    item nil
      )
      (setq item (read-line fp))
    )
  )
  (if data1
    (progn
      (setq maxs  (strlen data1)
	    count 1
	    chrct 1
      )
      (while (< count maxs)
	(if (/= "," (substr data1 count 1))
	  (setq chrct (1+ chrct))
	  (setq	numb  (atof (substr data1 (1+ (- count chrct)) chrct))
		dlist (append dlist (list numb))
		chrct 1
	  )
	)
	(setq count (1+ count))
      )					
      (setq numb  (atof (substr data1 (1+ (- count chrct))))
	    dlist (append dlist (list numb))
      )
    )
  )
  (close fp)
)

(defun raf ()
(setq ra "")  

(if (= shaft2 "5")(progn
(if (or (= shaft1 "14") (= shaft1 "15"))
(setq ra (cond
((< DIA 1) "Ra=0,63")
((< DIA 5) "Ra=1,25")
((< DIA 25) "Ra=2,5")
((< DIA 31) "Rz=40")
( T "")))  
)

(if (or (= shaft1 "8") (= shaft1 "10") (= shaft1 "12"))
(setq ra (cond
((< DIA 3) "Ra=0,63")
((< DIA 9) "Ra=1,25")
((< DIA 22) "Ra=2,5")
((< DIA 31) "Rz=20")
( T "")))  
)
  
(if (= shaft1 "7")
(setq ra (cond
((< DIA 3) "Ra=0,63")
((< DIA 9) "Ra=1,25")
((< DIA 19) "Ra=2,5")
((< DIA 31) "Rz=20")
( T "")))  
)

(if (= shaft1 "6")
(setq ra (cond
((< DIA 3) "Ra=0,63")
((< DIA 9) "Ra=1,25")
((< DIA 19) "Ra=2,5")
((< DIA 25) "Rz=40")
( T "")))  
)))

(if (= shaft2 "6")(progn
(if (= shaft1 "5")
(setq ra (cond
((< DIA 2) "Ra=0,63")
((< DIA 9) "Ra=1,25")
((< DIA 19) "Ra=2,5")
((< DIA 25) "Rz=40")
( T "")))  
)

(if (= shaft1 "4")
(setq ra (cond
((< DIA 5) "Ra=1,25")
((< DIA 16) "Ra=2,5")
((< DIA 25) "Rz=40")
( T "")))  
)))

(if (or (and (= shaft2 "6")(= shaft1 "15"))
	(and (= shaft2 "7")(= shaft1 "17")))
(setq ra (cond
((< DIA 1) "Ra=0,63")
((< DIA 7) "Ra=1,25")
((< DIA 13) "Ra=2,5")
((< DIA 25) "Rz=20")
((< DIA 31) "Rz=40")
( T "")))  
)

(if (= shaft2 "7")
(if (or (= shaft1 "15") (= shaft1 "17") (= shaft1 "19"))
(setq ra (cond
((< DIA 1) "")
((< DIA 11) "Ra=2,5")
((< DIA 25) "Rz=20")
((< DIA 27) "Rz=40")
((< DIA 31) "Rz=80")
( T "")))  
))

(if (= shaft1 "7")
(if (or (= shaft2 "7") (= shaft2 "8"))
(setq ra (cond
((< DIA 1) "")
((< DIA 11) "Ra=2,5")
((< DIA 25) "Rz=20")
((< DIA 27) "Rz=40")
((< DIA 31) "Rz=80")
( T "")))  
))

(if (or (and (= shaft2 "8")(= shaft1 "5"))
	(and (= shaft2 "8")(= shaft1 "4"))
	(and (= shaft2 "7")(= shaft1 "4")))
(setq ra (cond
((< DIA 5) "Ra=2,5")
((< DIA 13) "Rz=20")
((< DIA 25) "Rz=40")
((< DIA 31) "Rz=80")
( T "")))  
)

(if (and (= shaft2 "8")(= shaft1 "3"))
(setq ra (cond
((< DIA 3) "Ra=2,5")
((< DIA 11) "Rz=20")
((< DIA 25) "Rz=40")
((< DIA 31) "Rz=80")
( T "")))  
)

(if (= shaft2 "10")(progn
(if (or (= shaft1 "7") (= shaft1 "3"))
(setq ra (cond
((< DIA 3) "Rz=20")
((< DIA 13) "Rz=40")
((< DIA 31) "Rz=80")
( T "")))  
)

(if (or (= shaft1 "0") (= shaft1 "1") (= shaft1 "2"))
(setq ra (cond
((< DIA 1) "Rz=20")
((< DIA 9) "Rz=40")
((< DIA 31) "Rz=80")
( T "")))  
)))

(if (= shaft2 "11")
(if (or (= shaft1 "1") (= shaft1 "7"))
(setq ra (cond
((< DIA 3) "Rz=40")
((< DIA 13) "Rz=80")
((< DIA 31) "Rz=160")
( T "")))  
))

(if (and (= shaft2 "13")(= shaft1 "7"))
(setq ra (cond
((< DIA 3) "Rz=80")
((< DIA 13) "Rz=160")
((< DIA 31) "Rz=320")
( T "")))  
)

)
(PRINC)